
use census
go

--Plan: Spatial-1
DECLARE @latlonPoint geometry = geometry::Parse('POINT (45.518066 -122.767464)')
EXECUTE sp_executesql 
N'SELECT a.id, a.shape.STAsText() 
FROM zipcodes a 
WHERE a.shape.STIntersects(@latlonPoint)=1', 
N'@latlonPoint geometry', @latlonPoint

use AdventureWorks2008R2
go

CREATE PROC dbo.Top5LimitDistance (@g1 geography)
AS
SELECT TOP(5) SpatialLocation.ToString(), City 
FROM Person.Address
WHERE SpatialLocation.STDistance(@g1) < 100000
ORDER BY SpatialLocation.STDistance(@g1)
GO

-- Plan: Spatial-2
DECLARE @g geography = 'POINT(-121.626 47.8315)';
EXEC dbo.Top5LimitDistance @g
GO

SELECT TOP 100000 IDENTITY(int,1,1) AS n 
INTO dbo.numbers 
FROM MASTER..spt_values a, MASTER..spt_values b
 
CREATE UNIQUE CLUSTERED INDEX idx_1 ON numbers(n)

-- Plan: Spatial-3
DECLARE @start FLOAT = 1000; 
DECLARE @g geography = 'POINT(-121.626 47.8315)'; 
WITH NearestPoints AS
(
   SELECT TOP(5) SpatialLocation.ToString() loc, City, SpatialLocation.STDistance(@g) as dist, n
   FROM dbo.numbers 
   JOIN Person.Address T with (index=Index_geography_HHHH_Address) 
   ON T.SpatialLocation.STDistance(@g) < @start*POWER(2,dbo.numbers.n)
   ORDER BY dbo.numbers.n
)
SELECT * FROM NearestPoints
ORDER BY n, dist

